/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.dailyschedule;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.sos.dailyschedule.db.DailyScheduleDBItem;
import com.sos.hibernate.classes.DbItem;
import com.sos.hibernate.classes.SOSHibernateFilter;

/**
* \class DailyScheduleFilter 
* 
* \brief DailyScheduleFilter - 
* 
* \details
*
* \section DailyScheduleFilter.java_intro_sec Introduction
*
* \section DailyScheduleFilter.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 14.12.2011
* \see reference
*
* Created on 14.12.2011 13:53:37
 */

public class DailyScheduleFilter extends SOSHibernateFilter implements com.sos.hibernate.interfaces.ISOSHibernateFilter {

	@SuppressWarnings("unused")
	private final String	conClassName	= "DailyScheduleFilter";
	private String dateFormat         = "yyyy-MM-dd HH:mm:ss";
	private Date plannedFrom;
	private Date executedFrom;
	private Date plannedTo;
	private Date executedTo;
	private boolean onlyJobs=false;
	private boolean onlyJobChains=false;
	private boolean late=false;
	private String status="";
	private String schedulerId="";
	private String searchField;
	 
	public DailyScheduleFilter() {
		//
	}

	public Date getPlannedFrom() {
		return plannedFrom;
	}



	public void setPlannedFrom(Date plannedFrom) {
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd 00:00:00");
	    String d = formatter.format(plannedFrom);
		try {
			formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			this.plannedFrom = formatter.parse(d);
		}
		catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void setPlannedFrom(String plannedFrom) throws ParseException {
		if (plannedFrom.equals("")) {
			this.plannedFrom = null;
		}
		else {
			SimpleDateFormat formatter = new SimpleDateFormat(dateFormat);
			Date d = formatter.parse(plannedFrom);
			setPlannedFrom(d);
		  }
		}

	public void setPlannedFrom(String plannedFrom, String dateFormat) throws ParseException {
		this.dateFormat = dateFormat;
		setPlannedFrom(plannedFrom);
		}

	public void setPlannedTo(String plannedTo, String dateFormat) throws ParseException {
		this.dateFormat = dateFormat;
		setPlannedTo(plannedTo);
		}

	public String getDateFormat() {
		return dateFormat;
	}

	public void setDateFormat(String dateFormat) {
		this.dateFormat = dateFormat;
	}


	public Date getExecutedFrom() {
		return executedFrom;
	}


	public void setExecutedFrom(Date executedFrom) {
		this.executedFrom = executedFrom;
	}

	public void setExecutedFrom(String executedFrom) throws ParseException {
		if (executedFrom.equals("")) {
			this.executedFrom = null;
		}
		else {
			SimpleDateFormat formatter = new SimpleDateFormat(dateFormat);
			Date d = formatter.parse(executedFrom);
			setExecutedFrom(d);
		  }
		}

	public Date getPlannedTo() {
		return plannedTo;
	}



	public void setPlannedTo(Date plannedTo) {
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd 23:59:59");
	    String d = formatter.format(plannedTo);
		try {
			formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			this.plannedTo = formatter.parse(d);
		}
		catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
	}

	public void setPlannedTo(String plannedTo) throws ParseException {
	if (plannedTo.equals("")) {
		this.plannedTo = null;
	}
	else {
		SimpleDateFormat formatter = new SimpleDateFormat(dateFormat);
		Date d = formatter.parse(plannedTo);
		setPlannedTo(d);
	  }
	}
	
	public Date getExecutedTo() {
		return executedTo;
	}


	public void setExecutedTo(Date executedTo) {
		this.executedTo = executedTo;
	}
	
	public void setExecutedTo(String executedTo) throws ParseException {
		if (executedTo.equals("")) {
			this.executedTo = null;
		}
		else {
			SimpleDateFormat formatter = new SimpleDateFormat(dateFormat);
			Date d = formatter.parse(executedTo);
			setExecutedTo(d);
		  }
		}
	
	
	public boolean isFiltered(DbItem dbitem) {
	  DailyScheduleDBItem h = (DailyScheduleDBItem) dbitem;
	  return(
			 this.isLate() && !h.getExecutionState().isLate() || 
			 this.isOnlyJobChains()	&& h.getJobChain() == null || 
			 !this.getStatus().equals("") && !this.getStatus().equalsIgnoreCase(h.getExecutionState().getExecutionState())	|| 
			 this.getSearchField() != null && !this.getSearchField().equals("") && 
			 
	 		 ((h.getJobName() != null && !h.getJobName().toLowerCase().contains(this.getSearchField().toLowerCase())) ||
			 (h.getJobChain() != null && h.getOrderId() != null && !h.getOrderId().toLowerCase().contains(this.getSearchField().toLowerCase()) && !h.getJobChain().toLowerCase().contains(this.getSearchField().toLowerCase()))) ||
 			 this.isOnlyJobs() && h.getJob() == null);
		 //handled by sql !this.getSchedulerId().equals("") && !this.getSchedulerId().equalsIgnoreCase(h.getSchedulerId())	|| 

	}


	public String getSearchField() {
		return searchField;
	}

	public void setSearchFiled(String searchField) {
		this.searchField = searchField;
	}

	public boolean isOnlyJobs() {
		return onlyJobs;
	}


	public void setOnlyJobs(boolean onlyJobs) {
		this.onlyJobs = onlyJobs;
	}


	public boolean isOnlyJobChains() {
		return onlyJobChains;
	}



	public void setOnlyJobChains(boolean onlyJobChains) {
		this.onlyJobChains = onlyJobChains;
	}



	public boolean isLate() {
		return late;
	}



	public void setLate(boolean late) {
		this.late = late;
	}



	public String getStatus() {
		return status;
	}



	public void setStatus(String status) {
		this.status = status;
	}
	
	
	public String getSchedulerId() {
		return schedulerId;
	}



	public void setSchedulerId(String schedulerId) {
		this.schedulerId = schedulerId;
	}
	
	 

	@Override
	public String getTitle() {
		
		String s = "";
		if (schedulerId != null) {
			   s += String.format(schedulerId) + " ";
		}
		if (plannedFrom != null) {
			   s += String.format("from: %s " ,date2Iso(plannedFrom));
		}

		if (plannedTo != null) {
			   s += String.format("to: %s " ,date2Iso(plannedTo));
		}
		if (executedFrom != null) {
			   s += String.format("from: %s " ,date2Iso(executedFrom));
		}

		if (executedTo != null) {
			   s += String.format("to: %s " ,date2Iso(executedTo));
		}
		if (onlyJobs ) {
			   s += String.format(" Jobs ");
		}
		if (onlyJobChains ) {
			   s += String.format(" Jobchains ");
		}
		if (late ) {
			   s += String.format(" late ");
		}
		 
		return s;
	}


}
