/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.jobnet.classes;

 

import org.apache.log4j.Logger;
import org.eclipse.swt.SWT;
 
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;
 

 
import com.sos.jobnet.db.JobNetPlanDBItem;
import com.sos.hibernate.classes.DbItem;
import com.sos.hibernate.interfaces.ISOSTableItem;

/**
* \class JobNetTableItem 
* 
* \brief JobNetTableItem - 
* 
* \details
*
* \section JobNetTableItem.java_intro_sec Introduction
*
* \section JobNetTableItem.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 14.12.2011
* \see reference
*
* Created on 14.12.2011 13:51:13
 */

public class SosJobNetTableItem extends TableItem implements ISOSTableItem {
	private JobNetPlanDBItem jobNetPlanDBItem=null;
    private  String[] textBuffer = null;
	private static Logger					logger						= Logger.getLogger(SosJobNetTableItem.class);


	public SosJobNetTableItem(Table arg0, int arg1) {
		super(arg0, arg1);
 	}
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
		} 
	
	public DbItem getData() {
		return (JobNetPlanDBItem) super.getData();
	}
	
	public void setDBItem(DbItem d) {
	    jobNetPlanDBItem = (JobNetPlanDBItem) d;
		this.setData(d);
	} 
    
	public void setColor() {
		 org.eclipse.swt.graphics.Color red = Display.getDefault().getSystemColor(SWT.COLOR_RED);
 	     org.eclipse.swt.graphics.Color blue = Display.getDefault().getSystemColor(SWT.COLOR_BLUE);
		 org.eclipse.swt.graphics.Color white = Display.getDefault().getSystemColor(SWT.COLOR_WHITE);
		 org.eclipse.swt.graphics.Color gray = Display.getDefault().getSystemColor(SWT.COLOR_WIDGET_LIGHT_SHADOW);
		 org.eclipse.swt.graphics.Color black = Display.getDefault().getSystemColor(SWT.COLOR_BLACK);
		 org.eclipse.swt.graphics.Color yellow = Display.getDefault().getSystemColor(SWT.COLOR_YELLOW);

		 this.setForeground(black);
		 this.setBackground(white);
	         
	}
	
	public void setColumns() {
	    JobNetPlanDBItem d = jobNetPlanDBItem;

		logger.debug("...creating tableItem: " + d.getPlanId() + ":" + getParent().getItemCount());
	
		textBuffer = new String[] { d.getUuid(),
				                    String.valueOf(d.getNodeId()),
				                    String.valueOf(d.getExitCode()),
				                    d.getExitMessage(),
				                    String.valueOf(d.getStatusWaiter()),
				                    String.valueOf(d.getStatusRunner()),
				                    String.valueOf(d.getStatusDispatcher()),
				                    String.valueOf(d.getIsWaiterSkipped()),
				                    String.valueOf(d.getIsRunnerSkipped()),
				                    String.valueOf(d.getIsDispatcherSkipped()),
                                    String.valueOf(d.getState()),
                                    d.getPlannedStartTimeFormated(),
                                    d.getStartTimeFormated(),
                                    d.getEndTimeFormated(),
                                    d.getMessage()
				                    };
		this.setText(textBuffer);
	}
	
	public String[] getTextBuffer() {
		return textBuffer;
	}
	@SuppressWarnings("unused")
	private final String	conClassName	= "JobNetTableItem";


    @Override
    public Color getBackground() {
        // TODO Auto-generated method stub
        return null;
    }
    @Override
    public Color getForeground() {
        // TODO Auto-generated method stub
        return null;
    }


 
	

}
