/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/


package com.sos.jobnet.options;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.apache.log4j.Logger;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import com.sos.JSHelper.Basics.JSToolBox;
import com.sos.JSHelper.Listener.JSListenerClass;
import com.sos.JSHelper.Logging.Log4JHelper;

/**
 * \class 		JobNetOptionsJUnitTest - title
 *
 * \brief 
 *
 *

 *
 * see \see C:\Users\oh\AppData\Local\Temp\scheduler_editor-5087541472510475735.html for (more) details.
 * 
 * \verbatim ;
 * mechanicaly created by C:\ProgramData\sos-berlin.com\jobscheduler\scheduler.oh\config\JOETemplates\java\xsl\JSJobDoc2JSJUnitOptionSuperClass.xsl from http://www.sos-berlin.com at 20120227231545 
 * \endverbatim
 *
 * \section TestData Eine Hilfe zum Erzeugen einer HashMap mit Testdaten
 *
 * Die folgenden Methode kann verwendet werden, um fr einen Test eine HashMap
 * mit sinnvollen Werten fr die einzelnen Optionen zu erzeugen.
 *
 * \verbatim
 private HashMap <String, String> SetJobSchedulerSSHJobOptions (HashMap <String, String> pobjHM) {
	pobjHM.put ("		JobNetOptionsJUnitTest.auth_file", "test");  // This parameter specifies the path and name of a user's pr
		return pobjHM;
  }  //  private void SetJobSchedulerSSHJobOptions (HashMap <String, String> pobjHM)
 * \endverbatim
 */
public class JobNetOptionsJUnitTest extends  JSToolBox {
	private final String					conClassName						= "JobNetOptionsJUnitTest"; //$NON-NLS-1$
		@SuppressWarnings("unused") //$NON-NLS-1$
	private static Logger		logger			= Logger.getLogger(JobNetOptionsJUnitTest.class);
	@SuppressWarnings("unused")
	private static Log4JHelper	objLogger		= null;
	
	protected JobNetOptions	objOptions			= null;
//	private JobNet objE = null;

	public JobNetOptionsJUnitTest() {
		//
	}

	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
		objLogger = new Log4JHelper("./log4j.properties"); //$NON-NLS-1$
//		objE = new JobNet();
//		objE.registerMessageListener(this);
//		objOptions = objE.Options();
		objOptions.registerMessageListener(this);
		
		JSListenerClass.bolLogDebugInformation = true;
		JSListenerClass.intMaxDebugLevel = 9;
	}

	@After
	public void tearDown() throws Exception {
	}


		

/**
 * \brief testcheck_interval : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testcheck_interval() {  // SOSOptionTime
    	 objOptions.check_interval.Value("30");
    	 assertEquals ("", objOptions.check_interval.Value(),"30");
    	 assertEquals ("", objOptions.check_interval.getTimeAsSeconds(),30);
    	 objOptions.check_interval.Value("1:30");
    	 assertEquals ("", objOptions.check_interval.Value(),"1:30");
    	 assertEquals ("", objOptions.check_interval.getTimeAsSeconds(),90);
    	 objOptions.check_interval.Value("1:10:30");
    	 assertEquals ("", objOptions.check_interval.Value(),"1:10:30");
    	 assertEquals ("", objOptions.check_interval.getTimeAsSeconds(),30+10*60+60*60);
    	
    }

                

/**
 * \brief testdelay_start_dispatcher : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testdelay_start_dispatcher() {  // SOSOptionTime
    	 objOptions.delay_start_dispatcher.Value("30");
    	 assertEquals ("", objOptions.delay_start_dispatcher.Value(),"30");
    	 assertEquals ("", objOptions.delay_start_dispatcher.getTimeAsSeconds(),30);
    	 objOptions.delay_start_dispatcher.Value("1:30");
    	 assertEquals ("", objOptions.delay_start_dispatcher.Value(),"1:30");
    	 assertEquals ("", objOptions.delay_start_dispatcher.getTimeAsSeconds(),90);
    	 objOptions.delay_start_dispatcher.Value("1:10:30");
    	 assertEquals ("", objOptions.delay_start_dispatcher.Value(),"1:10:30");
    	 assertEquals ("", objOptions.delay_start_dispatcher.getTimeAsSeconds(),30+10*60+60*60);
    	
    }

                

/**
 * \brief testhibernate_connection_autocommit : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testhibernate_connection_autocommit() {  // SOSOptionBoolean
    	 objOptions.hibernate_connection_autocommit.Value("true");
    	 assertTrue ("", objOptions.hibernate_connection_autocommit.value());
    	 objOptions.hibernate_connection_autocommit.Value("false");
    	 assertFalse ("", objOptions.hibernate_connection_autocommit.value());
    	
    }

                

/**
 * \brief testhibernate_connection_config_file : 
 * 
 * \details
 * Hibernate configuration file of the database connection
 *
 */
    @Test
    public void testhibernate_connection_config_file() {  // SOSOptionInFileName
    	objOptions.hibernate_connection_config_file.Value("++hibernate.cfg.xml++");
    	assertEquals ("", objOptions.hibernate_connection_config_file.Value(),"++hibernate.cfg.xml++");
    	
    }

                

/**
 * \brief testhibernate_connection_driver_class : 
 * 
 * \details
 * Class of JBDC driver of the database connection
 *
 */
    @Test
    public void testhibernate_connection_driver_class() {  // SOSOptionDBDriver
    	objOptions.hibernate_connection_driver_class.Value("++oracle.jdbc.driver.OracleDriver++");
    	assertEquals ("", objOptions.hibernate_connection_driver_class.Value(),"++oracle.jdbc.driver.OracleDriver++");
    	
    }

                

/**
 * \brief testhibernate_connection_password : 
 * 
 * \details
 * Password of the database connection
 *
 */
    @Test
    public void testhibernate_connection_password() {  // SOSOptionPassword
    	objOptions.hibernate_connection_password.Value("++----++");
    	assertEquals ("", objOptions.hibernate_connection_password.Value(),"++----++");
    	
    }

                

/**
 * \brief testhibernate_connection_url : 
 * 
 * \details
 * JDBC URL of the database connection
 *
 */
    @Test
    public void testhibernate_connection_url() {  // SOSOptionJdbcUrl
    	 objOptions.hibernate_connection_url.Value("jdbc:oracle:thin:@localhost:1521:test");
    	 assertEquals ("", objOptions.hibernate_connection_url.Value(),"jdbc:oracle:thin:@localhost:1521:test");
    	
    }

                

/**
 * \brief testhibernate_connection_username : 
 * 
 * \details
 * User of the database connection
 *
 */
    @Test
    public void testhibernate_connection_username() {  // SOSOptionString
    	 objOptions.hibernate_connection_username.Value("++----++");
    	 assertEquals ("", objOptions.hibernate_connection_username.Value(),"++----++");
    	
    }

                

/**
 * \brief testhibernate_dialect : 
 * 
 * \details
 * Hibernate dialect of the database connection
 *
 */
    @Test
    public void testhibernate_dialect() {  // SOSOptionString
    	 objOptions.hibernate_dialect.Value("++org.hibernate.dialect.Oracle10gDialect++");
    	 assertEquals ("", objOptions.hibernate_dialect.Value(),"++org.hibernate.dialect.Oracle10gDialect++");
    	
    }

                

/**
 * \brief testhibernate_format_sql : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testhibernate_format_sql() {  // SOSOptionBoolean
    	 objOptions.hibernate_format_sql.Value("true");
    	 assertTrue ("", objOptions.hibernate_format_sql.value());
    	 objOptions.hibernate_format_sql.Value("false");
    	 assertFalse ("", objOptions.hibernate_format_sql.value());
    	
    }

                

/**
 * \brief testhibernate_show_sql : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testhibernate_show_sql() {  // SOSOptionBoolean
    	 objOptions.hibernate_show_sql.Value("true");
    	 assertTrue ("", objOptions.hibernate_show_sql.value());
    	 objOptions.hibernate_show_sql.Value("false");
    	 assertFalse ("", objOptions.hibernate_show_sql.value());
    	
    }

                

/**
 * \brief testis_bootstrap_order : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testis_bootstrap_order() {  // SOSOptionBoolean
    	 objOptions.is_bootstrap_order.Value("true");
    	 assertTrue ("", objOptions.is_bootstrap_order.value());
    	 objOptions.is_bootstrap_order.Value("false");
    	 assertFalse ("", objOptions.is_bootstrap_order.value());
    	
    }

                

/**
 * \brief testjobnet : 
 * 
 * \details
 * Name of the job net
 *
 */
    @Test
    public void testjobnet() {  // SOSOptionString
    	 objOptions.jobnet.Value("++----++");
    	 assertEquals ("", objOptions.jobnet.Value(),"++----++");
    	
    }

                

/**
 * \brief testmax_number_of_checks : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testmax_number_of_checks() {  // SOSOptionInteger
    	 objOptions.max_number_of_checks.Value("12345");
    	 assertEquals ("", objOptions.max_number_of_checks.Value(),"12345");
    	 assertEquals ("", objOptions.max_number_of_checks.value(),12345);
    	 objOptions.max_number_of_checks.value(12345);
    	 assertEquals ("", objOptions.max_number_of_checks.Value(),"12345");
    	 assertEquals ("", objOptions.max_number_of_checks.value(),12345);
    	
    }

                

/**
 * \brief testnode : 
 * 
 * \details
 * Name of the job net node
 *
 */
    @Test
    public void testnode() {  // SOSOptionString
    	 objOptions.node.Value("++----++");
    	 assertEquals ("", objOptions.node.Value(),"++----++");
    	
    }

                

/**
 * \brief testpredesessor_nodes : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testpredesessor_nodes() {  // SOSOptionString
    	 objOptions.predesessor_nodes.Value("++----++");
    	 assertEquals ("", objOptions.predesessor_nodes.Value(),"++----++");
    	
    }

                

/**
 * \brief testscheduler_id : 
 * 
 * \details
 * ID of the JobScheduler (Cluster)
 *
 */
    @Test
    public void testscheduler_id() {  // SOSOptionSchedulerID
    	objOptions.scheduler_id.Value("++----++");
    	assertEquals ("", objOptions.scheduler_id.Value(),"++----++");
    	
    }

                

/**
 * \brief testscript_to_execute : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testscript_to_execute() {  // SOSOptionScript
    	objOptions.script_to_execute.Value("++dir++");
    	assertEquals ("", objOptions.script_to_execute.Value(),"++dir++");
    	
    }

                

/**
 * \brief testskipDispatcher : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testskipDispatcher() {  // SOSOptionBoolean
    	 objOptions.skipDispatcher.Value("true");
    	 assertTrue ("", objOptions.skipDispatcher.value());
    	 objOptions.skipDispatcher.Value("false");
    	 assertFalse ("", objOptions.skipDispatcher.value());
    	
    }

                

/**
 * \brief testskipRunner : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testskipRunner() {  // SOSOptionBoolean
    	 objOptions.skipRunner.Value("true");
    	 assertTrue ("", objOptions.skipRunner.value());
    	 objOptions.skipRunner.Value("false");
    	 assertFalse ("", objOptions.skipRunner.value());
    	
    }

                

/**
 * \brief testskipWaiter : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testskipWaiter() {  // SOSOptionBoolean
    	 objOptions.skipWaiter.Value("true");
    	 assertTrue ("", objOptions.skipWaiter.value());
    	 objOptions.skipWaiter.Value("false");
    	 assertFalse ("", objOptions.skipWaiter.value());
    	
    }

                

/**
 * \brief testsuccessor_nodes : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testsuccessor_nodes() {  // SOSOptionString
    	 objOptions.successor_nodes.Value("++----++");
    	 assertEquals ("", objOptions.successor_nodes.Value(),"++----++");
    	
    }

                

/**
 * \brief testuuid_jobnet_identifier : 
 * 
 * \details
 * 
 *
 */
    @Test
    public void testuuid_jobnet_identifier() {  // SOSOptionUUID
    	objOptions.uuid_jobnet_identifier.Value("++----++");
    	assertEquals ("", objOptions.uuid_jobnet_identifier.Value(),"++----++");
    	
    }

                
        
} // public class JobNetOptionsJUnitTest
