/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.model;
import org.apache.log4j.Logger;

import com.sos.JSHelper.Annotations.JSOptionDefinition;
import com.sos.JSHelper.Options.JSOptionsClass;
import com.sos.JSHelper.Options.SOSOptionHostName;
import com.sos.JSHelper.Options.SOSOptionJSTransferMethod;
import com.sos.JSHelper.Options.SOSOptionPortNumber;

/**
* \class SchedulerObjectFactoryOptions 
* 
* \brief SchedulerObjectFactoryOptions - 
* 
* \details
*
* \section SchedulerObjectFactoryOptions.java_intro_sec Introduction
*
* \section SchedulerObjectFactoryOptions.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author KB
* @version $Id$18.01.2011
* \see reference
*
* Created on 18.01.2011 13:15:34
 */
public class SchedulerObjectFactoryOptions extends JSOptionsClass {
	private static final long	serialVersionUID	= -7712192294207358955L;
	private final String		conClassName		= "SchedulerObjectFactoryOptions";
	@SuppressWarnings("unused")
	private static final Logger	logger				= Logger.getLogger(SchedulerObjectFactoryOptions.class);
	/**
	 * \option UDPPortNumber
	 * \type SOSOptionPortNumber
	 * \brief UDPPortNumber - The tcp-port of the scheduler instance
	 *
	 * \details
	 * The scheduler communication port
	 *
	 * \mandatory: true
	 *
	 * \created 18.01.2011 13:23:19 by KB
	 */
	@JSOptionDefinition(name = "UDPPortNumber", description = "The scheduler communication port for UDP", key = "UDPPortNumber", type = "SOSOptionPortNumber", mandatory = true)
	public SOSOptionPortNumber	UDPPortNumber	= new SOSOptionPortNumber( // ...
														this, // ....
														conClassName + ".UDPPortNumber", // ...
														"The scheduler communication port for UDP", // ...
														"4444", // ...
														"4444", // ...
														true);

	public String getUDPPortNumber() {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::getPortNumber";
		return UDPPortNumber.Value();
	} // public String getUDPPortNumber

	public SchedulerObjectFactoryOptions setUDPPortNumber(final String pstrValue) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setPortNumber";
		UDPPortNumber.Value(pstrValue);
		return this;
	} // public SchedulerObjectFactoryOptions setUDPPortNumber
	/**
	 * \option PortNumber
	 * \type SOSOptionPortNumber
	 * \brief PortNumber - The tcp-port of the scheduler instance
	 *
	 * \details
	 * The scheduler communication port
	 *
	 * \mandatory: true
	 *
	 * \created 18.01.2011 13:23:19 by KB
	 */
	@JSOptionDefinition(name = "PortNumber", description = "The scheduler communication port", key = "PortNumber", type = "SOSOptionPortNumber", mandatory = true)
	public SOSOptionPortNumber	PortNumber	= new SOSOptionPortNumber( // ...
													this, // ....
													conClassName + ".PortNumber", // ...
													"The scheduler communication port", // ...
													"0", // ...
													"4444", // ...
													true);

	public String getPortNumber() {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::getPortNumber";
		return PortNumber.Value();
	} // public String getPortNumber

	public SchedulerObjectFactoryOptions setPortNumber(final String pstrValue) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setPortNumber";
		PortNumber.Value(pstrValue);
		return this;
	} // public SchedulerObjectFactoryOptions setPortNumber
	/**
	 * \option ServerName
	 * \type SOSOptionString
	 * \brief ServerName - Name of Server of JobScheduler Instance
	 *
	 * \details
	 * The Name of the Server
	 *
	 * \mandatory: true
	 *
	 * \created 18.01.2011 12:07:48 by KB
	 */
	@JSOptionDefinition(name = "ServerName", description = "The Name of the Server", key = "ServerName", type = "SOSOptionString", mandatory = true)
	public SOSOptionHostName			ServerName		= new SOSOptionHostName( // ...
																this, // ....
																conClassName + ".ServerName", // ...
																"The Name of the Server", // ...
																"0.0.0.0", // ...
																"localhost", // ...
																true);
	/**
	 * \option TransferMethod
	 * \type SOSOptionJSTransferMethod
	 * \brief TransferMethod - How to communicate with the JobScheduler
	 *
	 * \details
	 * The technical method of how to communicate with the JobScheduler
	 *
	 * \mandatory: true
	 *
	 * \created 26.04.2011 12:22:06 by KB
	 */
	@JSOptionDefinition(name = "TransferMethod", description = "The technical method of how to communicate with the JobScheduler", key = "TransferMethod", type = "SOSOptionJSTransferMethod", mandatory = true)
	public SOSOptionJSTransferMethod	TransferMethod	= new SOSOptionJSTransferMethod( // ...
																this, // ....
																conClassName + ".TransferMethod", // ...
																"The technical method of how to communicate with the JobScheduler", // ...
																"tcp", // ...
																"tcp", // ...
																true);

	public String getTransferMethod() {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::getTransferMethod";
		return TransferMethod.Value();
	} // public String getTransferMethod

	public SchedulerObjectFactoryOptions setTransferMethod(final String pstrValue) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setTransferMethod";
		TransferMethod.Value(pstrValue);
		return this;
	} // public SchedulerObjectFactoryOptions setTransferMethod

	public String getServerName() {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::getServerName";
		return ServerName.Value();
	} // public String getServerName

	public SchedulerObjectFactoryOptions setServerName(final String pstrValue) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::setServerName";
		ServerName.Value(pstrValue);
		return this;
	} // public SchedulerObjectFactory setServerName

	public SchedulerObjectFactoryOptions() {
		objParentClass = this.getClass();
	}
}
