#!/bin/sh
#
# ------------------------------------------------------------
# Company: Software- und Organisations-Service GmbH
# Author : Andreas Pschel <andreas.pueschel@sos-berlin.com>
# Author : Oliver Haufe <oliver.haufe@sos-berlin.com>
# Dated  : 2011-05-23
# Purpose: start FTP Processing
# ------------------------------------------------------------
#
CLASSPATH_BASE="%{INSTALL_PATH}"
if [ ! -d "$CLASSPATH_BASE" ]
then
  echo "Classpath directory \"$CLASSPATH_BASE\" does not exist."
  exit 1
fi
test -z "$JAVA_HOME" && JAVA_HOME="%{JAVA_HOME}"
JAVA_BIN="$JAVA_HOME/bin/java"

CP="$CLASSPATH_BASE/commons-net-2.2.jar:$CLASSPATH_BASE/log4j-1.2.16.jar:$CLASSPATH_BASE/mail.jar:$CLASSPATH_BASE/trilead-ssh2-build211.jar:$CLASSPATH_BASE/xalan.jar"
SOS_JARS="connection configuration JobSchedulerLocalization JSHelper marshalling net settings textprocessor util VirtualFileSystem xml"

# set_classpath
for SOS_JAR in $SOS_JARS
do
  SOS_JAR2=""
  for SOS_JAR1 in `ls "$CLASSPATH_BASE"/com.sos.$SOS_JAR-*-*-*.jar 2>/dev/null`
  do
    SOS_JAR2=$SOS_JAR1
  done
  test -z "$SOS_JAR2" || CP="$CP:$SOS_JAR2"
done

"$JAVA_BIN" -classpath "$CP" sos.net.SOSFTPCommand "$@" -current_pid=$$ -ppid=$PPID
