/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package sos.scheduler.job;

import sos.settings.SOSConnectionSettings;
import sos.spooler.Order;
import sos.spooler.Variable_set;


public class JobSchedulerCreateSequence extends JobSchedulerJob {
	
	private String paramName;
	
	private String application="scheduler";
	
	private String section = "counter";
	
	private String counter;

	public boolean spooler_process() throws Exception {
		if (getConnection()==null) throw new Exception("Job needs database connection");
		try{
			Variable_set params = spooler.create_variable_set(); 
			Order order = spooler_task.order();
			Variable_set orderParams = order.params();
			if (spooler_task.params() != null) params.merge(spooler_task.params());
            if (spooler_job.order_queue() != null) params.merge(orderParams);
            
            if (params.value("sequence_param_name") != null && params.value("sequence_param_name").length() > 0) {
                paramName = params.value("sequence_param_name");
                counter = paramName;
                spooler_log.info(".. parameter [sequence_param_name]: " + paramName);
            } else {
                throw new Exception("no parameter [sequence_param_name] was specified");
            }
            
            if (params.value("sequence_application") != null && params.value("sequence_application").length() > 0) {
            	application = params.value("sequence_application");
                spooler_log.info(".. parameter [sequence_application]: " + application);
            } else application = "scheduler";
            
            if (params.value("sequence_section") != null && params.value("sequence_section").length() > 0) {
            	section = params.value("sequence_section");
                spooler_log.info(".. parameter [sequence_section]: " + section);
            } else section="counter";
            
            if (params.value("sequence_counter") != null && params.value("sequence_counter").length() > 0) {
            	counter = params.value("sequence_counter");
                spooler_log.info(".. parameter [sequence_counter]: " + counter);
            }
            
            
            String seqNr = getConnectionSettings().getSequenceAsString(application, section, counter);
            getConnection().commit();
            
            spooler_log.info("Setting order paramter ["+paramName+"] to "+seqNr);
            orderParams.set_var(paramName, seqNr);
		} catch (Exception e){
			throw new Exception("Error generating sequence number: "+e);
		}
		return true;
	}
	
}
