/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: sos_java.h 13870 2010-06-03 15:29:33Z jz $

#ifndef __SOS_JAVA_H
#define __SOS_JAVA_H

#include "sosprof.h"
#include "../zschimmer/zschimmer.h"
#include "../zschimmer/java.h"

namespace sos {

//------------------------------------------------------------z::ptr<z::javabridge::Vm> get_java_vm

inline zschimmer::ptr<z::javabridge::Vm> get_java_vm( bool start = true )
{
    zschimmer::ptr<z::javabridge::Vm> vm = zschimmer::javabridge::Vm::get_vm( false );

    if( !vm->running()  &&  !vm->sos_initialized() )    
    {
        if( read_profile_bool( "", "java", "debug", false ) )  vm->set_debug( true );

        vm->set_javac_filename( z::subst_env( read_profile_string( "", "java"   , "javac"      , vm->javac_filename() ) ) );
        vm->set_filename      ( z::subst_env( read_profile_string( "", "java"   , "vm"         , vm->filename() ) ) );
        vm->prepend_class_path( z::subst_env( read_profile_string( "", "java"   , "class_path" ) ) );
        vm->new_instances     (               read_profile_string( "", "java"   , "instances"  ) );
        vm->set_options       ( z::subst_env( read_profile_string( "", "java"   , "options"    ) ) );

        vm->set_sos_initialized();  // Besser in Sos_static unterbringen (aber ohne java.h einzuziehen, nicht so einfach.)
    }

    if( start )  vm->start();

    return vm;
}

//----------------------------------------------------------------------------------java_is_running

inline bool java_is_running()
{
    return zschimmer::javabridge::Vm::get_vm( false )->running();
}

//-------------------------------------------------------------------------------------------------

} //namespace sos

#endif
