/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// sosfunc.h                                        1996 SOS GmbH Berlin
//                                                  Joacim Zschimmer

#ifndef __SOSFUNC_H
#define __SOSFUNC_H

#ifndef __DYNOBJ_H
#   include "dynobj.h"
#endif

#ifndef __SOSARRAY_H
#   include "sosarray.h"
#endif

namespace sos
{


typedef Sos_simple_array<Dyn_obj>  Sos_dyn_obj_array;

#define SOS_FUNC __cdecl
typedef void SOS_FUNC Sos_function( Dyn_obj* result, const Sos_dyn_obj_array& );


struct Sos_function_descr : Sos_self_deleting
{
                                Sos_function_descr      ();
                               ~Sos_function_descr      ();

    Fill_zero                  _zero_;
    Sos_string                 _name;
  //int                        _min_param_count;
  //int                        _max_param_count;
    int                        _param_count; 
    Sos_function*              _func;
  //Sos_ptr<Field_type>        _result_type;            // Erstmal nur Dyn_obj
  //Sos_ptr<Record_type>       _param_types;            // Erstmal nur Dyn_obj
  //Sos_ptr<Field_type>        _array_param_type;       // Wiederholungsparameter
};


struct Sos_function_register : Sos_self_deleting
{
                                Sos_function_register   ();
                               ~Sos_function_register   ();


    static Sos_function_register* init                  ();

    void                        add                     ( Sos_function*, const char* name, int param_count );
    void                        add                     ( const Sos_ptr<Sos_function_descr>& );
    void                        add                     ( Sos_function_descr* );
    Sos_function*               function                ( const char* name, int param_count )   { return function_descr( name, param_count )->_func; }
    Sos_function*               function_or_0           ( const char* name, int param_count );
    Sos_function_descr*         function_descr          ( const char* name, int param_count );
    Sos_function_descr*         function_descr_or_0     ( const char* name, int param_count );

    Fill_zero                  _zero_;
    Sos_simple_ptr_array< Sos_function_descr >  _func_array;
};


} //namespace sos

#endif

